//+------------------------------------------------------------------+
//|                                                 Breakthrough.mq4 |
//|                                                              Dan |
//|                                                Dan7974@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Dan"
#property link      "Dan7974@yahoo.com"

#property link      "Recovery modification by omelette, remodded by iZero"

extern bool BuyAtStart=false, SellAtStart=false;
extern int StopLoss=125, TakeProfit=150;
extern double Lots=0.1;
extern int Magic = 135790;

int Gate=0;
double SLots, Spread, PAB;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   Spread=Ask-Bid;
   SLots=Lots;
   
   int temp;
   double multlots;
   
   Gate = 0;
   
   if (temp == 0) {
    Print("No Open-Orders Found...");
    GlobalVariableSet("Breakthrough_AccountBalance",0); }
   else if (temp == 1) {
    Print("1 Open-Order Found - retrieving Order info...");
    multlots = Lots / SLots;
    while (multlots > 1) {
     multlots = multlots / 2;
     temp++; }
    Gate = MathMod(temp,3) * (1 - SellAtStart * 2);
    PAB = GlobalVariableGet("Breakthrough_AccountBalance");
    if (PAB == 0) {
     Print("ERROR ENCOUNTERED WITH SAVED ACCOUNT BALANCE - using current balance instead...");
     PAB = AccountBalance(); }
    Print("Order info retrieved - (Default lot size (",Lots,"), 'GATE' = ",Gate,", Account Balance = ",PAB,")");
   }
   else if (temp > 1) {
    Alert("ATTENTION! More than 1 Open-Order Found - this must be corrected manually...");
    Gate=1000000000; } 
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if (UninitializeReason() == 1)
    GlobalVariableDel("Breakthrough_AccountBalance");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(BuyAtStart==false && SellAtStart==false)
    {
     Alert("No buy or no sell selected! Restart the EA!");
     if (Gate == 0)
      Gate=1000000000;
    }
    
   if(BuyAtStart==true && SellAtStart==true)
    {
     Alert("Do not Select both buy and sell at the same time! Restart the EA!");
     if (Gate == 0)
      Gate=10000000000;
    }
    
   if(Gate==0)
    {
     if(BuyAtStart==true)
      {
       PAB=AccountBalance();
       int ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,25,(Ask-StopLoss*Point)-Spread,(Ask+TakeProfit*Point)-Spread,"",Magic,0,Green);
       Gate=1;
      }
      
      if(SellAtStart==true)
       {
        PAB=AccountBalance();
        ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,25,(Bid+StopLoss*Point)+Spread,(Bid-TakeProfit*Point)+Spread,"",Magic,0,Crimson);
        Gate=-1;
       }
    }
    
    if(Gate==1)
     {
      if(AccountBalance()<PAB)
       {
        PAB=AccountBalance();
        Lots*=2;
        ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,25,(Bid+StopLoss*Point)+Spread,(Bid-TakeProfit*Point)+Spread,"",Magic,0,Crimson);
        Gate=2;
       }
       
       if(AccountBalance()>PAB)
        {
         Lots=SLots;
         Gate=0;
        }
     }
     
     if(Gate==2)
      {
       if(AccountBalance()<PAB)
        {
         Lots*=2;
         Gate=0;
        }
        
        if(AccountBalance()>PAB)
         { 
          PAB=AccountBalance()+1;
          Lots=SLots/2;
          Gate=1;
         }
       }
             
//+------------------------------------------------------------------+

     if(Gate==-1)
     {
      if(AccountBalance()<PAB)
       {
        PAB=AccountBalance();
        Lots*=2;
        ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,25,(Ask-StopLoss*Point)-Spread,(Ask+TakeProfit*Point)-Spread,"",Magic,0,Green);
        Gate=-2;
       }
       
       if(AccountBalance()>PAB)
        {
         Lots=SLots;
         Gate=0;
        }
     }
     
     if(Gate==-2)
      {
       if(AccountBalance()<PAB)
        {
         Lots*=2;
         Gate=0;
        }
        
        if(AccountBalance()>PAB)
         { 
          PAB=AccountBalance()+1;
          Lots=SLots/2;
          Gate=-1;
         }
       }
   
   if (PAB > 0)
    GlobalVariableSet("Breakthrough_AccountBalance",PAB);    
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+